#! /usr/bin/python
# -*- coding: utf-8 -*-

#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
#
"""Commandes pour les listes.
Auteur: Pierre-Alexandre Fournie
Date: 07-11-2023
"""

# C'est tres bien de tester les commandes dans le script.
# note: 10/10
# Voir remarques plus bas.


import math


######################################
# Algorithme 0:                      #
# Exemple de commandes               #
######################################


l1 = ["toto",4,[2,3],3.14]      # declaration de liste
len(l1)                         # longueur de liste
l1[0]                           # element de l1 d'indice 0
l1[1]                           # element de l1 d'indice 1
l1[2]                           # element de l1 d'indice 2: c'est une liste
l1[len(l1)-1]                   # dernier element de l1
l1+[-1 ,0]                      # concatenation de l1 et de la liste [-1,0]
3*[2 ,3 ,4]                     # repetition de liste
l1.append(42)                   # ajout d'un element a la fin de l1
l1.extend([ -1 ,0])             # ajout de plusieurs elements a la fin de l1
del(l1[6])                      # suppression de l'element d'indice 6 dans l1
l1.remove('toto')               # suppression des elements "toto" dans l1
l1.insert(4,"titi")             # insertion de "titi" en indice 4 dans l1
list(range(5))                  # liste contenant les entiers de [[0;4]]]
list(range(3 ,7))               # liste contenant les entiers de [[3;6]]]
list(range(3,11,2))             # liste contenant les entiers de [[3;10]]] avec un pas de 2
l1[0:5]                         # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]]
l1[0:5:2]                       # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]] avec un pas de 2
l1[:5]                          # liste contenant tous les elements de l1 jusqu'a l'element d'indice 5
l1[4:]                          # liste contenant tous les elements de l1 a partir de l'element d'indice 4
l1[:]                           # liste contenant tous les elements de l1
l1[::2]                         # liste contenant tous les elements de l1 d'indice pair
l1[3]="tutu"                    # remplacement de l'element d'indice 3 de l1 par "tutu"
"toto" in l1                    # "toto" est-il dans l1?
3.14 in l1                      # 3.14 est-il dans l1?
l1.index(3.14)                  # recherche du premier indice de l'element 3.14
max([1,3,-1])                   # renvoie le maximum de la liste [1,3,-1]
sum([1,3,-1])                   # renvoie la somme des Ã©lÃ©ments de la liste [1,3,-1]

######################################
# Algorithme 1:                      #
# Faire une copie de liste           #
######################################
#print("1. Je regarde les valeurs de l1",l1)
l2=l1[:]
#print(l2)
l1.append("Test1")
#print("2. Je regarde les valeurs de l1",l1)
#print("3. Je regarde les valeurs de l2",l2)
l2.append("Test2")
#print("4. Je regarde les valeurs de l1", l1)
#print("5. Je regarde les valeurs de l2",l2)

l2=l1

#print(" 1.1 Je regarde les valeurs de l2",l2)
l1.append("Test1.1")
#print("1.2 Je regarde les valeurs de l1",l1)
#print(l2)
l2.append("Test2.2")
#print("1.3 Je regarde les valeurs de l1",l1)
#print("1.4 Je regarde les valeurs de l2",l2)

# Bon protocole.

######################################
# La 2ème ligne de code pose problème car lorsque je modifie la liste 1 je modifie aussi la liste 2
# Le protocole est : j'ajoute une valuer dans la liste 1, je regarde la liste 1 pui sj'ajoute une valeur dans la liste 2 et je regarde si la liste 1 est modifier
######################################

######################################
# Algorithme 2:                      #
# Creation de liste par fonction     #
######################################

l3=[i**2 for i in range(5)]
l4=[i**2 for i in range(1,6,2)]
l5=[(x,y) for x in range(1,7) for y in range(1,7) if x!=y]
#print(l3)
#print(l4)
#print(l5)
l6=[i**(-1) for i in range(2,51,2)]
#print(l6)
l7=[(x,y) for x in range(1,101) for y in range(1,101) if (x*y)%4==0]
#print(l7)


######################################
# Algorithme 3:                      #
# Fonction ProduitScalaire           #
######################################

l8= [4, 8]
l9= [2, 4]
def ProduitScalaire (l8, l9):

    resultat = (l8[0]*l9[0]+ l8[1]*l9[1])
    return(resultat)
print(ProduitScalaire(l8, l9))

######################################
# Algorithme 4:                      #
# Fonction Norme                     #
######################################
l10 = [2, 3]

def Norme(l10):
    resultat_norme = math.sqrt((l10[0])**2 + (l10[1])**2)
    return(resultat_norme)
print(Norme(l10))


######################################
# Algorithme 5:                      #
# Fonction Determinant               #
######################################

def Determinant(l8, l9):
    resultat_det = (l8[0]*l9[1] - l8[1]*l9[0])
    return(resultat_det)
print(Determinant(l8, l9))

######################################
# Algorithme 6:                      #
# Fonction  SontColineaires          #
######################################

# Attention, faire un return plutot qu'un print sur une fonction.

def SontColineaires(l8, l9):
    if Determinant(l8, l9) == 0: print(True)
    else : print(False)
SontColineaires(l8, l9)


######################################
# Algorithme 7:                      #
# Fonction Pol2Cart                  #
######################################

l11 = [1, math.pi/2]
def Pol2Cart(l11):
    x = l11[0]*math.cos(l11[1])
    y = l11[0]*math.sin(l11[1])
    return(x, y)
print(Pol2Cart(l11))

######################################
# Algorithme 8:                      #
# Fonction Cart2Pol                  #
######################################

l12 = [5, 4]

def Cart2Pol(l12):
    r = Norme(l12)
    angle = 2*math.atan((l12[1])/(l12[0]+r))
    return(r, angle)
print(Cart2Pol(l12))

######################################
# Algorithme 9:                      #
# Fonction EqDroiteOrth              #
######################################

l13 = [1, 1]
l14 = [2 , 1]

def EqDroiteOrth(l13, l14):
    a = l14[0]
    b = l14[1]
    c = l14[0]*l13[0] + l14[1]*l13[1]

    return(f"{a}x + {b} y = c")
print(EqDroiteOrth(l13,l14))

######################################
# Algorithme 10:                     #
# Fonction EqDroiteCol               #
######################################

def EqDroiteCol(l13, l14):
    a = -1*l14[1]
    b = l14[0]
    c = -1*l14[1]*l13[0] + l14[0]*l13[1]

    return(f"{a}x + {b} y = c")
print(EqDroiteCol(l13,l14))

######################################
# Algorithme 11:                     #
# Fonction Barycentre                #
######################################


# TB.

S1 = [[[0, 0], 1], [[4, 4], 1]]
S2 = [[[0, 0], 1], [[4, 4], 1], [[-2, 2], 2]]

def Barycentre(S):
    en_x = 0
    en_y = 0
    poids_total = 0
    
    for i in range(len(S)):
        en_x += S[i][0][0] * S[i][1]
        en_y += S[i][0][1] * S[i][1]
        poids_total += S[i][1]
    
    coordonnee_en_x = en_x / poids_total
    coordonnee_en_y = en_y / poids_total
    
    return (coordonnee_en_x, coordonnee_en_y)

print(Barycentre(S2))

    
    
    
######################################
# Algorithme 12:                     #
# Algorithme bonus                   #
######################################
point = 0

# Attention, on parle de disque et non de cercle!

for x in range(-100, 101):
    for y in range(-100, 101):
        if x**2 + y**2 == 100**2: # Condition incorrecte, ecrire plutot x**2 + y**2 <= 100**2
            point += 1

print(point)
