from math import *

# J'importe la biblioteque en entier, ou pourrait simplement innmporter les fonction utile pour optimiser le programme

# ! /usr/bin/python
# -*- coding: utf-8 -*-

#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
#
"""Commandes pour les listes.
Auteur: Pierre-Alexandre Fournie
Date: 07-11-2023
"""

# Tres bon travail.
# Note: 10/10
# Une ou deux betises, voir plus bas les remarques.


######################################
# Algorithme 0:                      #
# Exemple de commandes               #
######################################

"""
l1 = ["toto",4,[2,3],3.14]      # declaration de liste
len(l1)                         # longueur de liste
l1[0]                           # element de l1 d'indice 0
l1[1]                           # element de l1 d'indice 1
l1[2]                           # element de l1 d'indice 2: c'est une liste
l1[len(l1)-1]                   # dernier element de l1
l1+[-1 ,0]                      # concatenation de l1 et de la liste [-1,0]
3*[2 ,3 ,4]                     # repetition de liste
l1.append(42)                   # ajout d'un element a la fin de l1
l1.extend([ -1 ,0])             # ajout de plusieurs elements a la fin de l1
del(l1[6])                      # suppression de l'element d'indice 6 dans l1
l1.remove('toto')               # suppression des elements "toto" dans l1
l1.insert(4,"titi")             # insertion de "titi" en indice 4 dans l1
list(range(5))                  # liste contenant les entiers de [[0;4]]]
list(range(3 ,7))               # liste contenant les entiers de [[3;6]]]
list(range(3,11,2))             # liste contenant les entiers de [[3;10]]] avec un pas de 2
l1[0:5]                         # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]]
l1[0:5:2]                       # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]] avec un pas de 2
l1[:5]                          # liste contenant tous les elements de l1 jusqu'a l'element d'indice 5
l1[4:]                          # liste contenant tous les elements de l1 a partir de l'element d'indice 4
l1[:]                           # liste contenant tous les elements de l1
l1[::2]                         # liste contenant tous les elements de l1 d'indice pair
l1[3]="tutu"                    # remplacement de l'element d'indice 3 de l1 par "tutu"
"toto" in l1                    # "toto" est-il dans l1?
3.14 in l1                      # 3.14 est-il dans l1?
l1.index(3.14)                  # recherche du premier indice de l'element 3.14
max([1,3,-1])                   # renvoie le maximum de la liste [1,3,-1]
sum([1,3,-1])                   # renvoie la somme des Ã©lÃ©ments de la liste [1,3,-1]
"""

######################################
# Algorithme 1:                      #
# Faire une copie de liste           #
######################################

# l2=l1[:]
# l2=l1

# Celui qui pose le probleme est la deuxieme methode car il vas associer le meme enmplacement mémoire et donc si on
# modifie l'une l'autre est modifier aussi. TB.


######################################
# Algorithme 2:                      #
# Creation de liste par fonction     #
######################################

# l3 = [i ** 2 for i in range(5)]
# l4 = [i ** 2 for i in range(1, 6, 2)]
# l5 = [(x, y) for x in range(1, 7) for y in range(1, 7) if x != y]


l6 = [1 / i for i in range(2, 51, 2)] # TB.
# print(l6)
l7 = [(x, y) for x in range(1, 101) for y in range(1, 101) if (x * y) % 4 == 0]
# print(l7)


vecteur1 = [1, 2]
vecteur2 = [3, 4]
vecteur3 = [-3, -48]
vecteur4 = [0, 0]
vecteur5 = [2, 4]


# Vecteur utiliser pour verifier et tester les programmes

######################################
# Algorithme 3:                      #
# Fonction ProduitScalaire           #
######################################

def produitscalaire(a, b):
    return a[0] * b[0] + a[1] * b[1]


# print(produitscalaire(vecteur1, vecteur2))


######################################
# Algorithme 4:                      #
# Fonction Norme                     #
######################################

def norme(a):
    return sqrt((a[0] ** 2) + (a[1] ** 2))


# print(norme(vecteur3))


######################################
# Algorithme 5:                      #
# Fonction Determinant               #
######################################

def determinent(a, b):
    return (a[0] * b[1]) - (a[1] * b[0])


# print(determinent(vecteur2, vecteur1))


######################################
# Algorithme 6:                      #
# Fonction  SontColineaires          #
######################################

def sontcolineaires(a, b):
    if determinent(a, b) == 0:
        return True
    else:
        return False


# print(sontcolineaires(vecteur1, vecteur4))


######################################
# Algorithme 7:                      #
# Fonction Pol2Cart                  #
######################################

# a = [ρ, θ]
def Pol2Cart(a):
    x = a[0] * cos(a[1])
    y = a[0] * sin(a[1])
    return x, y


# print(Pol2Cart([sqrt(3**2+3**2),pi/4]))


######################################
# Algorithme 8:                      #
# Fonction Cart2Pol                  #
######################################

# a = [x,y]
def cart2pol(a):
    p = norme(a)
    if a[0] > 0:
        return [p, atan(a[1] / a[0])]
    if a[0] < 0:
        return [p, atan(a[1] / a[0])] # il faut aouter pi a l angle dans ce cas!
    else:
        if a[1] > 0:
            return [p, pi / 2]
        elif a[1] < 0:
            return [p, -pi / 2]
        else:
            return[0, 0]


# print(cart2pol([0, 0]))


######################################
# Algorithme 9:                      #
# Fonction EqDroiteOrth              #
######################################

# a point
# b vecteur
def EqDroiteOrth(a, b):
    a = b[0]
    b = b[1]
    c = b[0] * a[0] - b[1] * a[1]
    return [a, b, c]


######################################
# Algorithme 10:                     #
# Fonction EqDroiteCol               #
######################################

# a point
# b vecteur
def EqDroiteCol(a, b):
    """
    formule cour : b[o]* (y - a[1]) = b[1] * (x - a[0])
    obj : a*x + b*y = c

                   b[o]*y -b[o]*a[1] = b[1]*x - b[1]*a[0]
                   -b[1]*x + b[o]*y = b[o]*a[1] - b[1]*a[0]
                   donc a = -b[1]
                        b = b[o]
                        c = b[o]*a[1] - b[1]*a[0]
    """
    a = -b[1]
    b = b[0]
    c = b[0] * a[1] - b[1] * a[0]
    return [a, b, c] # OK;


######################################
# Algorithme 11:                     #
# Fonction Barycentre                #
######################################

S1 = [[[0, 0], 1], [[4, 4], 1]]
S2 = [[[0, 0], 1], [[4, 4], 1], [[-2, 2], 2]]


def barycentre(S):
    xhaut = 0
    yhaut = 0
    bas = 0
    for i in range(len(S)):
        xhaut += S[i][1] * S[i][0][0]
        yhaut += S[i][1] * S[i][0][1]
        bas += S[i][1]
    xG = xhaut / bas
    yG = yhaut / bas
    return [xG, yG]


# print(barycentre(S2))


######################################
# Algorithme 12:                     #
# Algorithme bonus                   #
######################################

nombre = sum(1 for x in range(-100, 101) for y in range(-100, 101) if x ** 2 + y ** 2 <= 100 ** 2)

# print(nombre)
# 31 417
