# NOTE: 10
# Voir remarques


#! /usr/bin/python

# -*- coding: utf-8 -*-



#

# This program is free software; you can redistribute it and/or modify

# it under the terms of the GNU General Public License as published by

# the Free Software Foundation; either version 2 of the License, or

# (at your option) any later version.

#

# This program is distributed in the hope that it will be useful,

# but WITHOUT ANY WARRANTY; without even the implied warranty of

# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

# GNU General Public License for more details.

#

# You should have received a copy of the GNU General Public License

# along with this program; if not, write to the Free Software

# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.

#

"""Commandes pour les listes.

Auteur: Pierre-Alexandre Fournie

Date: 07-11-2023

"""





######################################

# Algorithme 0:                      #

# Exemple de commandes               #

######################################





l1 = ["toto",4,[2,3],3.14]      # declaration de liste

len(l1)                         # longueur de liste

l1[0]                           # element de l1 d'indice 0

l1[1]                           # element de l1 d'indice 1

l1[2]                           # element de l1 d'indice 2: c'est une liste

l1[len(l1)-1]                   # dernier element de l1

l1+[-1 ,0]                      # concatenation de l1 et de la liste [-1,0]

3*[2 ,3 ,4]                     # repetition de liste

l1.append(42)                   # ajout d'un element a la fin de l1

l1.extend([ -1 ,0])             # ajout de plusieurs elements a la fin de l1

del(l1[6])                      # suppression de l'element d'indice 6 dans l1

l1.remove('toto')               # suppression des elements "toto" dans l1

l1.insert(4,"titi")             # insertion de "titi" en indice 4 dans l1

list(range(5))                  # liste contenant les entiers de [[0;4]]]

list(range(3 ,7))               # liste contenant les entiers de [[3;6]]]

list(range(3,11,2))             # liste contenant les entiers de [[3;10]]] avec un pas de 2

l1[0:5]                         # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]]

l1[0:5:2]                       # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]] avec un pas de 2

l1[:5]                          # liste contenant tous les elements de l1 jusqu'a l'element d'indice 5

l1[4:]                          # liste contenant tous les elements de l1 a partir de l'element d'indice 4

l1[:]                           # liste contenant tous les elements de l1

l1[::2]                         # liste contenant tous les elements de l1 d'indice pair

l1[3]="tutu"                    # remplacement de l'element d'indice 3 de l1 par "tutu"

"toto" in l1                    # "toto" est-il dans l1?

3.14 in l1                      # 3.14 est-il dans l1?

l1.index(3.14)                  # recherche du premier indice de l'element 3.14

max([1,3,-1])                   # renvoie le maximum de la liste [1,3,-1]

sum([1,3,-1])                   # renvoie la somme des éléments de la liste [1,3,-1]



######################################

# Algorithme 1:                      #

# Faire une copie de liste           #

######################################



l2=l1[:]

l2=l1       #instruction défectueuse



######################################

# Algorithme 2:                      #

# Creation de liste par fonction     #

######################################



l3=[i**2 for i in range(5)]

l4=[i**2 for i in range(1,6,2)]

l5=[(x,y) for x in range(1,7) for y in range(1,7) if x!=y]

l6=[1/i for i in range(2,51,2)]

l7=[(x,y) for x in range(1,100) for y in range(1,100) if (x*y)%4==0]





######################################

# Algorithme 3:                      #

# Fonction ProduitScalaire           #

######################################



def ProduitScalaire(U,V):

    '''renvoie le produit scalaire de U et V'''

    return U[0]*V[0]+U[1]*V[1]





######################################

# Algorithme 4:                      #

# Fonction Norme                     #

######################################



from math import *

def Norme(U):



    return sqrt(U[0]**2+U[1]**2)



######################################

# Algorithme 5:                      #

# Fonction Determinant               #

######################################



def Determinant(U,V):



    return (U[1]*V[0])-(U[0]*V[1])





######################################

# Algorithme 6:                      #

# Fonction  SontColineaires          #

######################################



def SontColineaires(U,V):



    return (U[1]*V[0])-(U[0]*V[1])==0



######################################

# Algorithme 7:                      #

# Fonction Pol2Cart                  #

######################################



def Pol2Cart(A,B):

    A, B = coord_polaire

    x = A*cos(B)

    y = A*sin(B)

    return x, y



######################################

# Algorithme 8:                      #

# Fonction Cart2Pol                  #

######################################



def Cart2Pol(x,y):

    A = sqrt(x**2 + y**2)

    b = atan2(y,x)

    return A,B





######################################

# Algorithme 9:                      #

# Fonction EqDroiteOrth              #

######################################



def EDroiteOrth(point_A, vecteur_i):

    a, b = vecteur_i[0], vecteur_i[1]

    c = a * point_A[0] + b * point_A[1]

    return [a, b, c]





######################################

# Algorithme 10:                     #

# Fonction EqDroiteCol               #

######################################



def EqDroiteCo1(point_A, vecteur_i):

    a, b = -vecteur_i[1], vecteur_i[0]

    c = a * point_A[0] + b * point_A[1]

    return [a, b, c]





######################################

# Algorithme 11:                     #

# Fonction Barycentre                #

######################################



S1 = [[[0,0],1],[[4,4],1]]

S2 = [[[0,0],1],[[4,4],1],[[-2,2],2]]



######################################

# Algorithme 12:                     #

# Algorithme bonus                   #

######################################



import math



nombre_points = sum(1 for x in range(-100, 101) for y in range(-100, 101) if math.sqrt(x**2 + y**2) <= 100)



######################################
