# NOTE: 10
# Code original!
# voir les remarques


######################################
# Algorithme 0:                      #
# Exemple de commandes               #
######################################


l1 = ["toto",4,[2,3],3.14]      # declaration de liste
len(l1)                         # longueur de liste
l1[0]                           # element de l1 d'indice 0
l1[1]                           # element de l1 d'indice 1
l1[2]                           # element de l1 d'indice 2: c'est une liste
l1[len(l1)-1]                   # dernier element de l1
l1+[-1 ,0]                      # concatenation de l1 et de la liste [-1,0]
3*[2 ,3 ,4]                     # repetition de liste
l1.append(42)                   # ajout d'un element a la fin de l1
l1.extend([ -1 ,0])             # ajout de plusieurs elements a la fin de l1
del(l1[6])                      # suppression de l'element d'indice 6 dans l1
l1.remove('toto')               # suppression des elements "toto" dans l1
l1.insert(4,"titi")             # insertion de "titi" en indice 4 dans l1
list(range(5))                  # liste contenant les entiers de [[0;4]]]
list(range(3 ,7))               # liste contenant les entiers de [[3;6]]]
list(range(3,11,2))             # liste contenant les entiers de [[3;10]]] avec un pas de 2
l1[0:5]                         # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]]
l1[0:5:2]                       # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]] avec un pas de 2
l1[:5]                          # liste contenant tous les elements de l1 jusqu'a l'element d'indice 5
l1[4:]                          # liste contenant tous les elements de l1 a partir de l'element d'indice 4
l1[:]                           # liste contenant tous les elements de l1
l1[::2]                         # liste contenant tous les elements de l1 d'indice pair
l1[3]="tutu"                    # remplacement de l'element d'indice 3 de l1 par "tutu"
"toto" in l1                    # "toto" est-il dans l1?
3.14 in l1                      # 3.14 est-il dans l1?
l1.index(3.14)                  # recherche du premier indice de l'element 3.14
max([1,3,-1])                   # renvoie le maximum de la liste [1,3,-1]
sum([1,3,-1])                   # renvoie la somme des Ã©lÃ©ments de la liste [1,3,-1]

######################################
# Algorithme 1:                      #
# Faire une copie de liste           #
######################################

l2=l1[:] # Fais une copie de la liste l1 pour créer une nouvelle liste l2, de sorte que les deux listes soient indépendantes l'une de l'autre
l2=l1    # L'instruction l2 = l1 fait que les deux listes sont liées, donc si tu changes une, l'autre change aussi

######################################
# Algorithme 2:                      #
# Creation de liste par fonction     #
######################################

l3=[i**2 for i in range(5)]
l4=[i**2 for i in range(1,6,2)]
l5=[(x,y) for x in range(1,7) for y in range(1,7) if x!=y]

l6 = [1/i for i in range(2, 51, 2)]
l7 = [(x, y) for x in range(1, 101) for y in range(1, 101) if (x * y) % 4 == 0]

######################################
# Algorithme 3:                      #
# Fonction ProduitScalaire           #
######################################

def ProduitScalaire(a, b):
    return sum(ai * bi for ai, bi in zip(a, b))

# Exemple
v1 = [1, 2]
v2 = [3, 4]

Ps = ProduitScalaire(v1, v2)

print("Le produit scalaire est", Ps)

######################################
# Algorithme 4:                      #
# Fonction Norme                     #
######################################

import math

def Norme(x, y):
    # doit prendre une liste en entree!
    return math.sqrt(x**2 + y**2)

# Exemple
x_ex = 3
y_ex = 4

norme = Norme(x_ex, y_ex)

print("La norme du vecteur est", norme)

######################################
# Algorithme 5:                      #
# Fonction Determinant               #
######################################

def determinant(c, d):

    if len(c) != 2 or len(d) != 2:
        raise ValueError("Les vecteurs doivent être bidimensionnels.")

    return c[0] * d[1] - c[1] * d[0]

# Exemple
vec_c = [1, 2]
vec_d = [4, 3]

determinant = determinant(vec_c, vec_d)

print("Le déterminant des vecteurs est", determinant)


######################################
# Algorithme 6:                      #
# Fonction  SontColineaires          #
######################################

def SontColineaires(u, v):

    if len(u) != len(v):
        raise ValueError("Les vecteurs doivent avoir la même dimension.")

    for i in range(len(u)):
        if u[i] != 0 and v[i] != 0:
            rapport = u[i] / v[i] # que se passe-t-il si v[i]=0?
            return all(coord == rapport * v[i] for coord in u)

    return True  # Si l'un des vecteurs est nul, ils sont toujours colinéaires

# Exemple
v_u = [1, 3]
v_v = [2, 4]

coli = SontColineaires(v_u, v_v)

print(f"Les vecteurs sontcollineaires", coli)

######################################
# Algorithme 7:                      #
# Fonction Pol2Cart                  #
######################################

import math

def Pol2Cart(polar):

    rho, theta = polar
    x = rho * math.cos(math.radians(theta))
    y = rho * math.sin(math.radians(theta))

    return x, y

# Exemple
polaires = [5, 45]  # ρ = 5, θ = 45 degré
cartesiennes = Pol2Cart(polaires)
print("Coordonnées cartésiennes pour les coordonnées polaires", polaires,":", cartesiennes)

######################################
# Algorithme 8:                      #
# Fonction Cart2Pol                  #
######################################

import math

def Cart2Pol(cartesian):

    e, f = cartesian
    rho = math.sqrt(e**2 + f**2)
    theta = math.degrees(math.atan2(f, e)) # faire une disjonction selon le signe de x!

    return rho, theta

# Exemple d'utilisation
coor_cart = [3, 4]  # e = 3, f = 4

coor_pol = Cart2Pol(coor_cart)

print("Coordonnées polaires" , coor_cart, "est" ,coor_pol)

######################################
# Algorithme 9:                      #
# Fonction EqDroiteOrth              #
######################################

def EqDroiteOrth(A, vec_n):

    a, b = vec_n
    c = a * A[0] + b * A[1]

    return [a, b, c]

# Exemple
A = [2, 3]
vec_n = [4, -2]

coefficients = EqDroiteOrth(A, vec_n)
print(f"L'équation cartésienne de la droite est : {coefficients[0]}x + {coefficients[1]}y = {coefficients[2]}.")

######################################
# Algorithme 10:                     #
# Fonction EqDroiteCol               #
######################################

def EqDroiteCol(B, vec_dir):

    # ici, le critere est different!    
    a, b = vec_dir
    c = a * B[0] + b * B[1]

    return [a, b, c]

# Exemple
B = [2, 3]
vec_dir = [3, 2]

coefficients_eq = EqDroiteCol(B, vec_dir)

print(f"L'équation cartésienne de la droite collineaire est : {coefficients_eq[0]}x + {coefficients_eq[1]}y = {coefficients_eq[2]}.")


######################################
# Algorithme 11:                     #
# Fonction Barycentre                #
######################################

S1 = [[[0,0],1],[[4,4],1]]
S2 = [[[0,0],1],[[4,4],1],[[-2,2],2]]

def Barycentre(systeme):

    x, y, poids = 0, 0, 0

    for point, poids in systeme:
        x += point[0] * poids
        y += point[1] * poids
        poids += poids

    bar_x = x / poids
    bar_y = y / poids

    return [bar_x, bar_y]

# Exemple

bar_S1 = Barycentre(S1)
bar_S2 = Barycentre(S2)

print(f"Les coordonnées du barycentre de S1 sont : {bar_S1}.")
print(f"Les coordonnées du barycentre de S2 sont : {bar_S2}.")

######################################
# Algorithme 12:                     #
# Algorithme bonus                   #
######################################

nb_pts_ent = sum(1 for x in range(-100, 101) for y in range(-100, 101) if x**2 + y**2 <= 100**2)
print("Le nombre des points entiers sont", nb_pts_ent) # TB

