# Créé par chelouca, le 10/11/2023 en Python 3.7

#! /usr/bin/python
# -*- coding: utf-8 -*-

"""Commandes pour les listes.
Auteur: Pierre-Alexandre Fournie
Date: 07-11-2023
"""

# Bon travail
# Note: 10/10
# Voir les remarques plus bas.

######################################
# Algorithme 0:                      #
# Exemple de commandes               #
######################################


l1 = ["toto",4,[2,3],3.14]      # declaration de liste
len(l1)                         # longueur de liste
l1[0]                           # element de l1 d'indice 0
l1[1]                           # element de l1 d'indice 1
l1[2]                           # element de l1 d'indice 2: c'est une liste
l1[len(l1)-1]                   # dernier element de l1
l1+[-1 ,0]                      # concatenation de l1 et de la liste [-1,0]
3*[2 ,3 ,4]                     # repetition de liste
l1.append(42)                   # ajout d'un element a la fin de l1
l1.extend([ -1 ,0])             # ajout de plusieurs elements a la fin de l1
del(l1[6])                      # suppression de l'element d'indice 6 dans l1
l1.remove('toto')               # suppression des elements "toto" dans l1
l1.insert(4,"titi")             # insertion de "titi" en indice 4 dans l1
list(range(5))                  # liste contenant les entiers de [[0;4]]]
list(range(3 ,7))               # liste contenant les entiers de [[3;6]]]
list(range(3,11,2))             # liste contenant les entiers de [[3;10]]] avec un pas de 2
l1[0:5]                         # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]]
l1[0:5:2]                       # liste contenant les elements de l1 d'indices dans l'intervalle [[0;5]] avec un pas de 2
l1[:5]                          # liste contenant tous les elements de l1 jusqu'a l'element d'indice 5
l1[4:]                          # liste contenant tous les elements de l1 a partir de l'element d'indice 4
l1[:]                           # liste contenant tous les elements de l1
l1[::2]                         # liste contenant tous les elements de l1 d'indice pair
l1[3]="tutu"                    # remplacement de l'element d'indice 3 de l1 par "tutu"
"toto" in l1                    # "toto" est-il dans l1?
3.14 in l1                      # 3.14 est-il dans l1?
l1.index(3.14)                  # recherche du premier indice de l'element 3.14
max([1,3,-1])                   # renvoie le maximum de la liste [1,3,-1]
sum([1,3,-1])                   # renvoie la somme des Ã©lÃ©ments de la liste [1,3,-1]

######################################
# Algorithme 1:                      #
# Faire une copie de liste           #
######################################

l2=l1[:] # cette commande permet de crée l2 tout en créeant un nouvelle emplacement
#l2=l1    #l2 est un alias de L1. l'emplacement mémoir est le meme ce qui entraîne que toute modification ultérieure de l2 modifie aussi l1. TB!

######################################
# Algorithme 2:                      #
# Creation de liste par fonction     #
######################################

l3=[i**2 for i in range(5)]
l4=[i**2 for i in range(1,6,2)]
l5=[(x,y) for x in range(1,7) for y in range(1,7) if x!=y]
l6=[1/2,1/4,1/6,1/8,1/10,1/12,1/14,16,1/18,1/20,1/22,1/22,1/24,1/26,1/28,1/30,1/32,1/34,1/36,1/38,1/40,1/42,1/44,1/46,1/48,1/50] # ecrivez une commande plus simple!
l7=[(x,y)for x in range (1,100) for y in range (1,100) if (x*y)%4==0]

######################################
# Algorithme 3:                      #
# Fonction ProduitScalaire           #
######################################

def produit_scalaire(u,v):
    return u[0]*v[0]+u[1]*v[1]



U=[1,3]
V=[2,6]
print(produit_scalaire(U,V))




######################################
# Algorithme 4:                      #
# Fonction Norme                     #
######################################
u=[3,9]
def norme(u,v):
    return # ?
######################################
# Algorithme 5:                      #
# Fonction Determinant               #
######################################
A=[8,6]
B=[2,2]
def determinant (A,B):
    return  (A[0]*B[1]-B[0]*A[1])


######################################
# Algorithme 6:                      #
# Fonction  SontColineaires          #
######################################
def sontcolinéaires(A,B):
    return determinant(A,B)==0


######################################
# Algorithme 7:                      #
# Fonction Pol2Cart                  #
######################################
import math


def Pol2Cart(polar_coordinates):
    rho, theta = polar_coordinates
    x = rho * math.cos(math.radians(theta)) # conversion inutile car on donne theta en radians en general.
    y = rho * math.sin(math.radians(theta))
    return x, y
# par exemple :
polar_coords = [5, 45]  # Exemple avec ρ = 5 et θ = 45 degrés
cartesian_coords = Pol2Cart(polar_coords)

######################################
# Algorithme 8:                      #
# Fonction Cart2Pol                  #
######################################
import math

def Cart2Pol(cartesien_coord): # erreur de syntaxe dans la fonction. A revoir.
    x, y = cartesian_coordinates
    rho = math.hypot(x, y)
    theta = math.degrees(math.atan2(y, x)) # attention atan n'est pas toujours adaptee, par exemple pour x=0 ou x<=0.
    return rho, theta



######################################
# Algorithme 9:                      #
# Fonction EqDroiteOrth              #
######################################
def EqDroiteOrth(point_A, vecteur_normal):
    xA, yA = point_A
    a, b = vecteur_normal
 # L'équation cartésienne de la droite orthogonale est ax + by = c
    c = a * xA + b * yA

    return [a, b, c]


######################################
# Algorithme 10:                     #
# Fonction EqDroiteCol               #
######################################
def EqDroiteCol(point_A, vecteur_directeur):
    xA, yA = point_A
    u, v = vecteur_directeur

    # L'équation cartésienne de la droite colinéaire est ux - vy = c
    c = u * xA - v * yA

    return [u, -v, c] # TB


######################################
# Algorithme 11:                     #
# Fonction Barycentre                #
######################################

def Barycentre(systeme_pondere):
    barycentre_x, barycentre_y, poids_total = 0, 0, 0

    for (x, y), poids in systeme_pondere:
        barycentre_x += poids * x
        barycentre_y += poids * y
        poids_total += poids

    return barycentre_x / poids_total, barycentre_y / poids_total

# Test sur le système S1
systeme_S1 = [([0, 0], 1), ([4, 4], 1)]
barycentre_S1 = Barycentre(systeme_S1)
print(f"Barycentre de S1 : {barycentre_S1}")

# Test sur le système S2
systeme_S2 = [([0, 0], 1), ([4, 4], 1), ([-2, 2], 2)]
barycentre_S2 = Barycentre(systeme_S2)
print(f"Barycentre de S2 : {barycentre_S2}") # TB







######################################
# Algorithme 12:                     #
# Algorithme bonus                   #
######################################

nombre_points = sum(1 for x in range(-100, 101) for y in range(-100, 101) if x**2 + y**2 <= 100**2)
print(nombre_points)
